import java.awt.*;
import java.util.Vector;
import java.util.Enumeration;

/******************************************************************************/
/* class Floater                                                              */
/*                                                                            */
/* Represents one of the seven columns of cards in the lower part of the      */
/* playing area.                                                              */
/******************************************************************************/
public class Floater
{
  Pile creator        = null;
  Vector cards        = new Vector();
  public Point loc    = new Point(0,0);
  public Point offset = new Point(0,0);
  
  /****************************************************************************/
  /* Take a float.                                                            */
  /****************************************************************************/
  void setFloat(Vector v, Pile p, Point offset)
  {
    this.cards = v;
    this.creator = p;
    this.offset = offset;
  }  
   
  /****************************************************************************/
  /* Give the float back.                                                     */
  /****************************************************************************/
  Vector getFloat()
  {
    Vector retval = cards;
    
    cards   = new Vector();
    creator = null;
    
    return retval;
  }

  Component getCreator() { return creator; }
  
  int count() { return cards.size(); }
  
  boolean isEmpty() { return cards.isEmpty(); }
  
  /****************************************************************************/
  /* The bottom card is the one that determines if a drop is legal.           */
  /****************************************************************************/
  Card bottom() { return (Card)cards.firstElement(); }

  /****************************************************************************/
  /* Get and set the location on screen to draw the float.                    */
  /****************************************************************************/
  public Point getPosition()
  {
    return loc;
  }
  
  public void setPosition(Point pos)
  {
    loc = pos;
  }
  
  /****************************************************************************/
  /* Draw the cards face up, spaced vertically, at the Position.              */
  /****************************************************************************/
  public void draw(Graphics g)
  {
    Point pos = new Point(loc.x - offset.x, loc.y - offset.y);
    
    Enumeration e = cards.elements();
    
    while (e.hasMoreElements())
    {
      ((Card)e.nextElement()).draw(g, pos.x, pos.y, null);
      pos.y += Pile.Y_OFFSET;
    }        
  }
}
