import java.awt.*;
import java.awt.event.*;
import java.applet.Applet;

/******************************************************************************/
/* class Solitaire                                                            */
/******************************************************************************/
public class Solitaire extends Applet
{
  Tableau tableau;
   
  /****************************************************************************/
  /* Initialise the applet                                                    */
  /****************************************************************************/
  public void init()
  {
    Image image;
    
    // Initialisation of static members in Pile class
    image = getImage(getDocumentBase(), "cards/back999.gif");
    Pile.setBackImage(image);
    image = getImage(getDocumentBase(), "cards/bottom01.gif");
    Pile.setEmptyImage(image);
        
    setLayout(new BorderLayout());
    
    // New game button. Create and assemble.
    Button new_game = new Button("New Game");
    
    LightweightPanel p_button = new LightweightPanel();
    p_button.setLayout(new BorderLayout());
    p_button.add("East", new_game);
    
    add("North", p_button);
    
    // ActionListener for the button
    new_game.addActionListener(new ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        new_game();
      }
    });
    
    new_game();        
  }
 
  /****************************************************************************/
  /* Initialise the tableau.                                                  */
  /****************************************************************************/
  protected void new_game()
  {
    // Destroy and recreate the tableau
    if (tableau != null)
    {
      remove(tableau);
    }
    
    tableau = new Tableau(this);    
    
    add("Center", tableau);

    setVisible(true);    
    doLayout();
    repaint();    
  }
  
  /****************************************************************************/
  /* You get this method in Java 1.2, but not 1.1. So it needs implementing.  */
  /* We need to find the first non-Container component at a Point, if any.    */
  /****************************************************************************/
  public Component findComponentAt(Point p)
  {
    // p is relative to the tableau, not the applet.
    Component comp = tableau.getComponentAt(p);
    Component oldcomp = null;
        
    while (comp instanceof Container && comp != oldcomp)
    {
      oldcomp = comp;
      Point q = comp.getLocation();
      p.x = p.x - q.x;
      p.y = p.y - q.y;
      comp = comp.getComponentAt(p);
    }
  
    return comp;
  }
  
  /****************************************************************************/
  /* a standard overwriting of update()                                       */
  /****************************************************************************/
  public void update(Graphics g) 
  { 
    paint(g); 
  }
  
  public void paint(Graphics g)
  {
    paintComponents(g); 
  }

  public void stop()
  {
    // Stop the bouncer thread if necessary.
    tableau.completed = false;
  }    
}
