import java.util.Vector;

/******************************************************************************/
/* class Suit                                                                 */
/*                                                                            */
/* A class to distinguish between the 4 suits in a way that can be            */
/* type-checked.                                                              */
/******************************************************************************/
public final class Suit 
{
  public static Suit Clubs     = new Suit();
  public static Suit Diamonds = new Suit();
  public static Suit Hearts   = new Suit();
  public static Suit Spades   = new Suit();

  /****************************************************************************/
  /* We only have a private constructor                                       */
  /****************************************************************************/
  Suit() 
  {
    super();
  }  

  /****************************************************************************/
  /* Return a vector of the four Suits                                        */
  /****************************************************************************/
  public static Vector allSuits() 
  {

    Vector allsuits = new Vector(4);
    allsuits.addElement(Suit.Clubs);
    allsuits.addElement(Suit.Diamonds);
    allsuits.addElement(Suit.Hearts);
    allsuits.addElement(Suit.Spades);
  
    return allsuits;
  }

  
  /****************************************************************************/
  /* Test which suit this is                                                  */
  /****************************************************************************/
  public boolean isClubs()    { return this == Clubs;    }
  public boolean isDiamonds()  { return this == Diamonds; }
  public boolean isHearts()    { return this == Hearts;   }
  public boolean isSpades()    { return this == Spades;   }
  
  
  /****************************************************************************/
  /* Get the suit value as a letter                                           */
  /****************************************************************************/
  public char getLetter()
  {
    if (isClubs())    { return 'c'; }
    if (isDiamonds()) { return 'd'; }
    if (isHearts())   { return 'h'; }
    if (isSpades())   { return 's'; }
    else              { return 'x'; }
  }    
}

